*********************************************************************
* FCO Compiler Programm-Beispiel                                    *
* Copyright (C) KRS GmbH 1991                                       *
* Copyright (C) Sophco, Inc. 1989                                   *
* Alle Rechte vorbehalten                                           *
*********************************************************************
*                                                                   *
* Programmiert von.: Lawrence D. Hess                               *
* bersetzung......: Gnther Daubach                                *
* Programm.........: Original: BOOK.PRG, bersetzung: ADRBUCH.PRG   *
* Datum............: 05.10.91                                       *
* Zeit.............: 20:00                                          *
* Beschreibung.....: Beispiel zur Verwendung einiger FCO-Kommandos, *
*                    Funktionen und Prozeduren.                     *
*                                                                   *
*********************************************************************

*-- Folgende Anweisungen geben die einzulesenden Dateien an

#include SYSTEM.HDR
#include STRING.HDR
#include DATABASE.HDR
#include DATE.HDR
#include DATA.HDR
#include IO.HDR
#include PICK.HDR
#include MEMO.HDR


*-- Ausgabe von Warnungen steuern

#pragma W_INDIRECT-
#pragma W_FUNC_PROC-


*-- Datei ADRBUCH.HDR enthlt Datei- und Variablen-Deklarationen sowie
*   Prototyp-Deklarationen eigener Funktionen und Prozeduren

#define  MAIN                                   && Steuert die Deklarations-
                                                && art in ADRBUCH.HDR

#include ADRBUCH.HDR

*-- Memo-Feld editieren und anzeigen

PROCEDURE BOOKmemo_proc

VARDEF
   INT     SCREVAR                              && Zum Speichern des Bild-
ENDDEF                                          && schirm-Inhalts

   SCREVAR = SAVESCRN(5,1,20,75)                && Bildschirm sichern

  IF DoColor                                   && Farb-Anzeige?
    SET COLOR TO &CLRMEMO
    DO FILL WITH 5,1,20,75,"Ŀ"," ",&NUMMEMO,&NUMMEMO,6
  ELSE
    DO FILL WITH 5,1,20,75,"Ŀ"," ",15,15,6
  ENDIF

   @ 19,6 SAY '[ "Ctrl-W" - Speichern ]'

  IF .NOT. M_EXIST(BOOK->COMMENT)              && Hat Satz einen Memo-
                                               && Eintrag?
    M_OPEN(BOOK->COMMENT,&MO_CREATE)           && Memo ffnen und anlegen
  ELSE
    M_OPEN(BOOK->COMMENT,&MO_APPEND)           && Zum Anfgen ffnen
  ENDIF
   M_EDIT(BOOK->COMMENT,6,2,18,73,.F.)          && Memo bearbeiten
   M_CLOSE(BOOK->COMMENT)                       && Memo nach Bearbeitung
                                                && schlieen
   RESTORESCRN(SCREVAR)                         && alten Bildschirm anzeigen

ENDPRO


*-- Index-Reihenfolge ndern

PROCEDURE BOOK_INDEX

VARDEF
   LONG  PLIST                                  && Zeiger fr PICK-Liste
   INT   PVALUE                                 && Rckgabe von PICKLIST()
ENDDEF

  IF DoColor                                   && Farb-Anzeige ?
    SET COLOR TO &CLRWINDOW
  ENDIF

   PLIST = PICK_INIT()                          && PICK-Liste initialisieren
   PICK_ADD( PLIST, "NAME" )                    && Hinzufgen zur PICK-Liste
   PICK_ADD( PLIST, "STADT" )
   PICK_ADD( PLIST, "LAND" )
   PICK_ADD( PLIST, "PLZ" )

   @ 10,10 clear to 15,23                       && Bildschirm-Bereich lschen
   @ 10,10 to 15,23                             && Rahmen zeichnen
   pick_list (plist,11,11,14,22,pvalue,.f.,.f.) && PICK-Liste ausfhren

  IF lastkey() = &K_ESC                        && Abbruch bei ESC-Taste
    pick_clear(plist)                          && PICK-Liste lschen
    RETURN
  ENDIF
   SET ORDER TO pvalue                          && Index-Folge entsprechend
                                                && umschalten
   indord = pvalue

   pick_clear(plist)                            && PICK-Liste lschen

ENDPRO


*-- Nach einem Namen suchen

PROCEDURE FIND_PROC

VARDEF
    LONG     OLDREC
    INT      OLDSCRN
    INT      OLDORDER
enddef

    OLDREC   = recno()                          && Alte Satznummer sichern
    OLDSCRN  = SAVESCRN(5,10, 9,54)             && Bildschirm sichern
    OLDORDER = INDORD                           && Index-Folge sichern

    SET ORDER TO 1                              && Index nach Name whlen

   IF DoColor                                  && Farb-Anzeige ?
     SET COLOR TO &CLRWINDOW                   && Rahmen mit Schatten
                                               && ausgeben
   
     DO fill WITH 5,10, 9,54,"Ŀ"," ",&NUMWINDOW,&NUMWINDOW,6
   ELSE
     DO fill WITH 5,10, 9,54,"Ŀ"," ",15,15,6
   ENDIF

    FIND_LNAME = SPACE(25)
    @ 6,11 SAY "         Gesuchten Namen eingeben"
    @ 7,11 SAY "  Nachname:   " GET FIND_LNAME PICTURE "@!"
    READ

   IF lastkey() = &K_ESC                       && Abbruch, wenn ESC
     RETURN
   ENDIF


    SEEK trim(FIND_LNAME)                       && Satz suchen

   IF .NOT. FOUND()
     @ 22,0 SAY TRIM(FIND_LNAME)+" nicht gefunden."
   
     DELAY(5)                                  && 5 Sekunden oder Tasten-
                                               && druck abwarten
     @ 22,0 SAY SPACE(80)                      && Zeile lschen
     GO OLDREC                                 && Zurck auf alten Satz
   ENDIF

    RESTORESCRN(OLDSCRN)                        && Alten Bildschirm wieder-
                                                && herstellen

    SET ORDER TO OLDORDER                       && Alte Index-Folge wieder-
                                                && herstellen
ENDPRO


*-- Prfen, ob das eingegebene Datum gltig ist

FUNCTION  LOGICAL CHECK_DATE

   IF DTOC(DATA_BDATE) = "  .  .  "
     @ 22,0 SAY "ungltiges Datum."
     DELAY(5)                                  && 5 Sekunden oder Tasten-
                                               && druck abwarten
     @ 22,0 SAY SPACE(80)                      && Zeile lschen
     RETURN .F.                                && Falsches Datum wurde ein-
                                               && gegeben
   ELSE
     RETURN .T.                                && Datum ist gltig
   ENDIF

ENDFUNC


*-- Bildschirm-Maske anzeigen

PROCEDURE BOOK_LABELS

   IF DoColor                                  && Farb-Anzeige?
     SET COLOR TO &CLRWINDOW                   && Rahmen mit Schatten
                                               && zeichnen
   
     DO fill WITH 1,2,4,20,"Ŀ"," ",&NUMWINDOW,&NUMWINDOW,6
   ELSE
     DO fill WITH 1,2,4,20,"Ŀ"," ",15,15,6
   ENDIF

    @ 2,3 SAY "   Adressbuch   "

   IF DoColor
     DO FILL WITH 5,2,20,74,"Ŀ"," ",&NUMSTAND,&NUMSTAND,6
     SET COLOR TO 'BG+/B'
   ELSE
     DO FILL WITH 5,2,20,74,"Ŀ"," ",15,15,6
   ENDIF

    @  7, 5  SAY "Vorname "
    @  9, 6  SAY "Nachname "
    @  9,44  SAY "Geboren "
    @ 11, 8  SAY "Strae "
    @ 13,11  SAY "Ort "
    @ 15,10  SAY "Land "
    @ 15,21  SAY "PLZ "
    @ 17, 5  SAY "Tel. privat "
    @ 17,32  SAY "Tel. gesch. "

ENDPRO


*-- Daten-Eingabe

PROCEDURE BOOK_FIELDS

   IF DoColor
     SET COLOR TO &CLRSTAND
   ENDIF

    @  7,17 GET DATA_Fname
    @  9,17 GET DATA_Lname
    @  9,54 GET DATA_BDATE   PICTURE  "@D" VALID CHECK_DATE()
    @ 11,17 GET DATA_Addres
    @ 13,17 GET DATA_City
    @ 15,17 GET DATA_State   PICTURE  "@!"
    @ 15,31 GET DATA_Zip
    @ 17,17 GET DATA_Hphone
    @ 17,44 GET DATA_Wphone

ENDPRO


*-- Variablen zum Anfgen eines neuen Satzes lschen

PROCEDURE BOOKCLEAR_DATA

    DATA_Fname  = SPACE(25)
    DATA_Lname  = SPACE(25)
    DATA_Addres = SPACE(50)
    DATA_City   = SPACE(35)
    DATA_State  = SPACE(2)
    DATA_Zip    = SPACE(10)
    DATA_Hphone = SPACE(13)
    DATA_Wphone = SPACE(13)
    DATA_BDATE  = CTOD('  .  .  ')

ENDPRO


*-- Variablen mit den Daten aus einem Satz fllen

PROCEDURE BOOKASSIGN_DATA

    DATA_Fname  = BOOK->Fname
    DATA_Lname  = BOOK->Lname
    DATA_Addres = BOOK->Addres
    DATA_City   = BOOK->City
    DATA_State  = BOOK->State
    DATA_Zip    = BOOK->Zip
    DATA_Hphone = BOOK->Hphone
    DATA_Wphone = BOOK->Wphone
    DATA_BDATE  = BOOK->BDATE

ENDPRO


*-- Variablen im Satz speichern

PROCEDURE BOOKREPLACE_DATA

    REPLACE BOOK->Fname  WITH DATA_Fname
    REPLACE BOOK->Lname  WITH DATA_Lname
    REPLACE BOOK->Addres WITH DATA_Addres
    REPLACE BOOK->City   WITH DATA_City
    REPLACE BOOK->State  WITH DATA_State
    REPLACE BOOK->Zip    WITH DATA_Zip
    REPLACE BOOK->Hphone WITH DATA_Hphone
    REPLACE BOOK->Wphone WITH DATA_Wphone
    REPLACE BOOK->BDATE  WITH DATA_BDATE

ENDPRO


*-- Fragen, ob Eingabe gespeichert werden soll

PROCEDURE BOOKSAVE_DATA

    @ 22,0 SAY SPACE(80)
    @ 22,1 SAY "Speichern (J/N):" GET CHOOSE  PICTURE "!"
    READ

   IF CHOOSE = "N"                             && Rckkehr bei "N" oder ESC
     RETURN
   ELSE
    IF APPNDATA = "J"
      APPEND BLANK
    ENDIF
     DO BOOKREPLACE_DATA
   ENDIF

ENDPRO


*-- Bildschirm neu anzeigen

PROCEDURE BOOKVIEW_PROC

   IF EOF()
     @ 20,12 SAY "Keine Stze in der Datei"
   ELSE
     DO BOOK_LABELS
     DO BOOKASSIGN_DATA
     DO BOOK_FIELDS
     CLEAR GETS
   ENDIF

ENDPRO


*-- Hauptmen

PROCEDURE BOOKmain_proc

VARDEF
   UINT    idx
ENDDEF

   REPEAT
   
     DO BOOKview_proc
   
    IF DoColor
      SET COLOR TO &CLRSTAND
    ENDIF
   
     DO cursor_off                             && Cursor ausschalten
   
     @ 22 ,0 SAY SPACE(80)
     @ 23 ,0 SAY SPACE(80)
   
    IF deleted()
    
     IF DoColor                              && Farb-Anzeige ?
       SET COLOR to &CLRMESSAGE
     ENDIF
    
      @ 22,0 SAY center("gelscht",80)        && Anzeige, wenn gelscht
    
     IF DoColor                              && Farb-Anzeige ?
       SET COLOR to &CLRSTAND
     ENDIF
    
    ENDIF
   
     @ 23, 1 PROMPT "Anfg."        ;
             MESSAGE " Stze in der Datei hinzufgen"
   
     @ 23, 7 PROMPT "ndern"       ;
             MESSAGE " Angezeigten Satz ndern"
   
     @ 23,14 PROMPT "Zurck"       ;
             MESSAGE " Vorigen Satz anzeigen"
   
     @ 23,21 PROMPT "Nchster"     ;
             MESSAGE " Nchsten Satz anzeigen"
   
     @ 23,30 PROMPT "Memo"         ;
             MESSAGE " Bemerkung anzeigen/ndern"
   
     @ 23,35 PROMPT "Folge"        ;
             MESSAGE " Sortierfolge ndern"
   
     @ 23,41 PROMPT "Suchen"       ;
             MESSAGE " Einen bestimmten Satz suchen"
   
     @ 23,48 PROMPT "Lsch."       ;
             MESSAGE " Angezeigten Satz lschen/wiederherstellen"
   
     @ 23,55 PROMPT "Report"       ;
             MESSAGE " Liste oder Etiketten drucken"
   
     @ 23,62 PROMPT "Dienstprogr." ;
             MESSAGE " Komprimieren, Indizieren und Drucker einstellen"
   
     @ 23,75 PROMPT "Ende"         ;
             MESSAGE " Programm beenden"
   
     MENU TO idx
   
    IF lastkey() = &K_ESC                     && Abbruch bei ESC
      idx = 11
    ENDIF
   
    DO CASE
    
      *-- Hinzufgen --*
    CASE idx = 1
        DO cursor_on                          && Cursor einschalten
        DO BOOKCLEAR_data
        DO BOOK_FIELDS
        READ
       if lastkey() <> &K_ESC
         APPNDATA = "J"
         DO BOOKSAVE_DATA
         APPNDATA = "N"
       endif
    
        *-- ndern --*
    CASE idx = 2
        DO cursor_on                          && Cursor einschalten
        DO BOOK_FIELDS
        READ
       if lastkey() <> &K_ESC
         APPNDATA = "N"
         DO BOOKSAVE_DATA
       endif
    
      *-- Voriger Satz --*
    CASE idx = 3
        SKIP -1
        IF bof()
          GOTO TOP
        ENDIF
    
      *-- Nchster Satz --*
    CASE idx = 4
        SKIP +1
        IF eof()
          GOTO BOTTOM
        ENDIF
    
      *-- Bemerkung --*
    CASE idx = 5
        DO cursor_on                          && Cursor einschalten
        DO BOOKmemo_proc
    
      *-- Index-Folge --*
    CASE idx = 6
        DO BOOK_INDEX
    
      *-- Suchen --*
    CASE idx = 7
        DO cursor_on                          && Cursor einschalten
        DO find_proc
    
      *-- Lschen --*
    CASE idx = 8
        IF deleted()
          RECALL
        ELSE
          DELETE
        ENDIF
    
      *-- Drucken --*
    CASE idx = 9
        DO print_info
    
      *-- Hilfsprogramme --*
    CASE idx = 10
        DO util_proc
    
      *-- Programm-Ende --*
    CASE idx = 11
        __color_std = DOSColor                && Bildschirm-Attribut bei
                                              && Aufruf wiederherstellen
        CLEAR
        DO cursor_on                          && Cursor einschalten
        QUIT
    
    ENDCASE
   
   UNTIL idx = 12

ENDPRO


*-- Das Hauptprogramm

PROCEDURE fco_main
  parameters char(128) CmdZeile                 && Hier knnen Kommando-
                                                && zeilen-Parameter von DOS
                                                && bernommen werden

*-- Variablen, die in einer Prozedur oder Funktion deklariert werden, sind
*   nur in der Routine sichtbar, in der sie deklariert wurden

VARDEF
 CHAR(20) box_
enddef

    DOSColor = __color_std                      && System-Variable, enthlt
                                                && aktuelles Farb-Attri-
                                                && but fr Standard-Ausgabe

    DoColor = iscolor() .and. .not. ;           && Farb-Anzeige nur wenn
              ("MONO" $ upper(CmdZeile))        && Grafik-Adapter vorhanden
                                                && und wenn Aufruf nicht mit
                                                && dem Zusatz MONO erfolgte.
    CLEAR

   IF exist("BOOK.MEM")                        && Variablen-Datei lesen,
     RESTORE WHATPORT FROM "BOOK.MEM"          && falls vorhanden, sonst
   ELSE                                        && LPT1 als Vorgabe defi-
     WHATPORT = "LPT1"                         && nieren
   ENDIF
    SET PRINTER TO WHATPORT

    SET SCOREBOARD OFF
    SET MESSAGE TO 24
    SET EXACT OFF
    SET DATE GERMAN

*-- Hintergrund zeichnen

    SET COLOR TO 'N/W'
    box_ = chr(178)+chr(178)+chr(178)+chr(178)+chr(178)+chr(178)+chr(178);
          +chr(178)+chr(178)+chr(178)+chr(178)
    DO fill with 0,0,25,80,box_,box_,15,15,0

    SET COLOR TO 'W/N' 'N/W'

    DO file_check                               && Dateien auf Vorhandensein
                                                && prfen

    DO cursor_off                               && Cursor ausschalten

*-- Datenbank und Indexe ffnen

    OPEN "ADR.DBF" ALIAS BOOK INDEX NAME,ORT,LAND,PLZ

    INDORD = 1

    GOTO TOP

   IF eof()                                    && Wenn keine Stze in der
                                               && Datenbank, in den Modus
     DO BOOKCLEAR_data                         && "Neueingabe" gehen
     DO BOOK_LABELS
     DO cursor_on                              && Cursor einschalten
     DO BOOK_FIELDS
     READ
     APPNDATA = "J"
     DO BOOKSAVE_DATA
     APPNDATA = "N"
     DO cursor_off                             && Cursor ausschalten
     GOTO TOP
    IF .NOT. eof()
      DO BOOKmain_proc
    ENDIF
   ELSE
     DO BOOKmain_proc
   ENDIF

    CLOSE ALL
    __color_std = DOSColor                      && Bildschirm-Attribut bei
                                                && Aufruf wiederherstellen
    CLEAR
    DO cursor_on

ENDPRO

* EOF: ADRBUCH.PRG
