**********************************************************************
* FCO Compiler Programm-Beispiel                                     *
* Copyright (C) KRS GmbH 1991                                        *
* Copyright (C) Sophco, Inc. 1989                                    *
* Alle Rechte vorbehalten                                            *
**********************************************************************
*                                                                    *
* Programmiert von.: Lawrence D. Hess                                *
* bersetzung......: Gnther Daubach                                 *
* Programm.........: Original: UNBOOK.PRG, bersetzung: ADRBUCH1.PRG *
* Datum............: 05.10.91                                        *
* Zeit.............: 20:00                                           *
* Beschreibung.....: Beispiel zur Verwendung einiger FCO-Kommandos,  *
*                    Funktionen und Prozeduren.                      *
*                                                                    *
**********************************************************************

*-- Folgende Anweisungen geben die einzulesenden Dateien an

#INCLUDE SYSTEM.HDR
#INCLUDE STRING.HDR
#INCLUDE DATABASE.HDR
#INCLUDE IO.HDR

#include ADRBUCH.HDR

REPORTDEF  PHONE_BOOK                      && Report definieren

  HEADING        = "Telefonliste"
  WIDTH          = 80
  PAGE_LENGTH    = 60
  LEFT_MARGIN    = 0
  DOUBLE_SPACE   = .F.
  PLAIN          = .T.
  SUMMARY        = .F.

 COLUMNDEF
   HEADING                  = "NAME"
   WIDTH                    = 50
   DECIMALS                 = 0
   EXPRESSION CHAR          = TRIM(BOOK->FNAME)+" "+BOOK->LNAME
   TOTAL                    = .F.
 ENDDEF

 COLUMNDEF
   HEADING                  = "Tel. Firma"
   WIDTH                    = 13
   DECIMALS                 = 0
   EXPRESSION CHAR          = BOOK->WPHONE
   TOTAL                    = .F.
 ENDDEF

 COLUMNDEF
   HEADING                  = "Tel. privat"
   WIDTH                    = 13
   DECIMALS                 = 0
   EXPRESSION CHAR          = BOOK->HPHONE
   TOTAL                    = .F.
 ENDDEF

ENDDEF

LABELDEF  ADDRESS_LIST                     && Etikett definieren

  HEIGHT   = 5
  WIDTH    = 55
  MARGIN   = 0
  HORIZ_SP = 1
  VERT_SP  = 1
  ACROSS   = 1

  LINE     = TRIM(BOOK->FNAME)+" "+BOOK->LNAME
  LINE     = BOOK->ADDRES
  LINE     = TRIM(BOOK->STATE)+" "+TRIM(BOOK->ZIP)+" "+BOOK->CITY
  LINE     = " "

ENDDEF


*-- Prfen, ob alle Dateien vorhanden sind

PROCEDURE FILE_CHECK

    SAVE_AREA(22,0,22,79)

   IF .NOT. exist("ADR.DBF")             && Wenn Datei nicht vorhanden,
     @ 22,0 SAY SPACE(80)
     @ 22,0 SAY "Erzeuge --<ADR.DBF>--"  && neu anlegen
     BUILD "ADR.DBF" FROM ALIAS BOOK
   ENDIF

    OPEN "ADR.DBF" ALIAS BOOK

   IF .NOT. exist( "NAME.FDX" )           && Wenn Index nicht gefunden,
     @ 22,0 SAY SPACE(80)
     @ 22,0 SAY "Erzeuge --<NAME.FDX>--"  && neu anlegen
     INDEX "NAME.FDX" ALIAS NAME
   ENDIF

   IF .NOT. exist( "ORT.FDX" )
     @ 22,0 SAY SPACE(80)
     @ 22,0 SAY "Erzeuge --<ORT.FDX>--"
     INDEX "ORT.FDX" ALIAS ORT
   ENDIF

   IF .NOT. exist( "LAND.FDX" )
     @ 22,0 SAY SPACE(80)
     @ 22,0 SAY "Erzeuge --<LAND.FDX>--"
     INDEX "LAND.FDX" ALIAS LAND
   ENDIF

   IF .NOT. exist( "PLZ.FDX" )
     @ 22,0 SAY SPACE(80)
     @ 22,0 SAY "Erzeuge --<PLZ.FDX>--"
     INDEX "PLZ.FDX" ALIAS PLZ
   ENDIF

    CLOSE ALL

    RESTORE_AREA

ENDPRO


*-- Information ausgeben

PROCEDURE PRINT_INFO

VARDEF
  LONG  RECNUM
  INT   IDX
  INT   SCREVAR
ENDDEF

    SCREVAR = SAVESCRN(5,45,10,61)         && Bildschirm sichern

   REPEAT
     IF DoColor                           && Farb-Anzeige?
       SET COLOR TO &CLRWINDOW
       DO FILL WITH 5,45,12,61,"Ŀ"," ",&NUMWINDOW,&NUMWINDOW,6
     ELSE
       DO FILL WITH 5,45,12,61,"Ŀ"," ",15,15,6
     ENDIF
   
     @  6,47 SAY "Druck:"
     @  8,47 PROMPT "Etiketten   "
     @  9,47 PROMPT "Telefonliste"
     @ 10,47 PROMPT "Ende        "
     MENU TO IDX
   
     IF lastkey() = &K_ESC                && Abbruch bei ESC
       RETURN
     ENDIF
   
     RECNUM = RECNO()
   
    DO CASE
    
      *-- Etiketten --*
    CASE IDX = 1
       IF DoColor
         SET COLOR TO &CLRSTAND
       ENDIF
        @ 22,0 SAY "Bitte warten, Etiketten werden gedruckt.."
        GOTO TOP
        SET CONSOLE OFF
        LABEL FORM ADDRESS_LIST ALL TO PRINT
        SET CONSOLE ON
        @ 22,0 SAY SPACE(80)
    
      *-- Telefonliste --*
    CASE IDX = 2
       IF DoColor
         SET COLOR TO &CLRSTAND
       ENDIF
        @ 22,0 SAY "Bitte warten, Telefonliste wird gedruckt.."
        GOTO TOP
        SET CONSOLE OFF
        REPORT FORM PHONE_BOOK TO PRINT
        EJECT
        SET CONSOLE ON
        @ 22,0 SAY SPACE(80)
    
      *-- Ende --*
    CASE IDX = 3
        RESTORESCRN(SCREVAR)
        GO RECNUM
        RETURN
    
    ENDCASE
   
     GO RECNUM
   
   UNTIL IDX = 4

ENDPRO

*-- Datenbank komprimieren, d.h. alle gelscht markierten Stze entfernen

PROCEDURE PACK_DATA
VARDEF
  INT IDX
  INT SCRE
ENDDEF

   SCRE = SAVESCRN(9,35,13,56)             && Bildschirm sichern

  IF DoColor                              && Farb-Anzeige?
    SET COLOR TO &CLRWINDOW
    DO FILL WITH 9,35,13,56,"Ŀ"," ",&NUMWINDOW,&NUMWINDOW,6
  ELSE
    DO FILL WITH 9,35,13,56,"Ŀ"," ",15,15,6
  ENDIF

   @ 10,37 SAY "Datei verdichten?"
   @ 11,40 PROMPT "JA"
   @ 11,46 PROMPT "NEIN"
   MENU TO IDX

   RESTORESCRN(SCRE)

  DO CASE
  
  CASE IDX = 1
     IF DoColor
      SET COLOR TO &CLRSTAND
     ENDIF
      @ 22,0 SAY "Bitte warten, Datei wird verdichtet.."
      PACK
      @ 22,0 SAY SPACE(80)
  
  OTHERWISE
      RETURN
  
  ENDCASE

ENDPRO

*-- Index-Dateien neu aufbauen

PROCEDURE INDEX_BOOK

  IF DoColor
      SET COLOR TO &CLRSTAND
  ENDIF

   CLOSE INDEX                             && Vor Neu-Indizierung alle Index-
                                           && Dateien schlieen

   @ 22,0 SAY "Erzeuge --<NAME.FDX>--"     && Index-Dateien neu bilden
   INDEX "NAME.FDX" ALIAS NAME

   @ 22,0 SAY "Erzeuge --<ORT.FDX>--"
   INDEX "ORT.FDX" ALIAS ORT

   @ 22,0 SAY "Erzeuge --<LAND.FDX>--"
   INDEX "LAND.FDX" ALIAS LAND

   @ 22,0 SAY "Erzeuge --<PLZ.FDX>--  "
   INDEX "PLZ.FDX" ALIAS PLZ

   @ 22,0 SAY SPACE(80)

   SET INDEX TO NAME,ORT,LAND,PLZ          && Alle Index-Dateien neu ffnen

ENDPRO


*-- Drucker-Port auswhlen

PROCEDURE SET_PRINTER
VARDEF
  INT IDX
  INT SCRE
ENDDEF

    SCRE = SAVESCRN(5,25,13,41)            && Bildschirm sichern

   IF DoColor                             && Farb-Anzeige?
     SET COLOR TO &CLRWINDOW
     DO FILL WITH 5,25,13,41,"Ŀ"," ",&NUMWINDOW,&NUMWINDOW,6
   ELSE
     DO FILL WITH 5,25,13,41,"Ŀ"," ",15,15,6
   ENDIF

    @  6,27 SAY "Drucker-Port"
    @  8,27 PROMPT "1) LPT1"
    @  9,27 PROMPT "2) LPT2"
    @ 10,27 PROMPT "3) LPT3"
    @ 11,27 PROMPT "4) LPT4"
    MENU TO IDX

    RESTORESCRN(SCRE)

   IF lastkey() = &K_ESC                  && Abruch bei ESC
     RETURN
   ENDIF

    WHATPORT = "LPT"+i_str(IDX)
    SAVE WHATPORT TO "BOOK.MEM"            && Variable in einer Datei sichern

    SET PRINTER TO WHATPORT

ENDPRO

*-- Dienstprogramme

PROCEDURE UTIL_PROC
VARDEF
  INT IDX
  INT SCREVAR
ENDDEF

    SCREVAR = SAVESCRN(5,45,13,64)         && Bildschirm sichern

   REPEAT
   
    IF DoColor                           && Farb-Anzeige?
      SET COLOR TO &CLRWINDOW
      DO FILL WITH 5,45,13,64,"Ŀ"," ",&NUMWINDOW,&NUMWINDOW,6
    ELSE
      DO FILL WITH 5,45,13,64,"Ŀ"," ",15,15,6
    ENDIF
   
     @  6,47 SAY "Dienstprogramme"
     @  8,47 PROMPT "Verdichten   "
     @  9,47 PROMPT "Index-Aufbau "
     @ 10,47 PROMPT "Drucker-Port "
     @ 11,47 PROMPT "Ende         "
     MENU TO IDX
   
    IF lastkey() = &K_ESC                && Abruch bei ESC
      RESTORESCRN(SCREVAR)
      RETURN
    ENDIF
   
    DO CASE
    
      *-- Verdichten --*
    CASE IDX = 1
        DO PACK_DATA
    
      *-- Neu Indizieren --*
    CASE IDX = 2
        DO INDEX_BOOK
    
      *-- Drucker-Port setzen --*
    CASE IDX = 3
        DO SET_PRINTER
    
      *-- Ende --*
    CASE IDX = 4
        RESTORESCRN(SCREVAR)
        RETURN
    
    ENDCASE
   
   UNTIL IDX = 5

ENDPRO

* EOF: ADRBUCH1.PRG