*
* Demoprogramm - Version fr FCO
*

*** Standard-Definitionen einlesen
#include IO.HDR
#include keys.hdr
#include SYSTEM.HDR
#include STRING.HDR
#include STRING.HDR


*** Vorab-Deklarationen der eigenen Prozeduren und Funktionen
procedure schltg prototype
procedure schltf prototype

procedure title prototype
procedure verzoeg prototype
  parameters value long l
function uint main_menu prototype
function dbl t_diff prototype
  parameters const char anf, const char end
function dbl tim_to_secs prototype
  parameters const char tim
procedure dbtest prototype
procedure xudftest prototype
function char(26) cap_first prototype
  parameters const char(26) txt

*** Konstanten-Definition fr PROMPT-ID's
#define MSCHLTG 1
#define MSCHLTF 2
#define MDBTEST 3
#define MDBXUDF 4
#define MQUIT   99

*** Datenbank-Struktur-Deklaration
dbfdef test
  char(26) ftext
enddef

*** Index-Deklaration
indexdef
  char(26) testx test->ftext
  char(26) testu cap_first(test->ftext)
enddef

*** Globale Variablen-Deklaration
vardef
  uint ch
enddef

*** Hauptprozedur
procedure fco_main

  parameters char(128) dos_cmd   && DOS-Kommandozeile


  vardef                         && lokale Variablen deklarieren
    uint choice
  enddef

  set scoreboard off
  do cursor_off                  && Cursor ausschalten
  do title                       && Titelbildschirm anzeigen
  do while .t.                   && Haupt-Programmschleife
    choice = main_menu()         && Men-Auswahl holen

    do case                      && Funktionsauswahl
      case choice = &MSCHLTG
        do schltg
      case choice = &MSCHLTF
        do schltf
      case choice = &MDBTEST
        do dbtest
      case choice = &MDBXUDF
        do xudftest
      case choice = &MQUIT
        clear
        do cursor_on
        quit
    endcase
  enddo
endpro                           && Prozedur-Ende

procedure schltg                 && Schleifen-Test mit long-Zhlvariable

  vardef                         && lokale Variablen deklarieren
    long i
    char(8) t_anf, t_end
  enddef

  clear
  @  0, 0 to 24,79 double
  @  2,17 say "FCO Demoprogramm - Schleifentest (Ganzzahl)"
  @  3,17 say ""
  @  5,17 say "In diesem Programmteil wird eine leere FOR..."
  @  6,17 say "NEXT-Schleife  300.000-mal  durchlaufen.  Als"
  @  7,17 say "Zhlvariable  dient  eine  long-Zahl.  Dieser"
  @  8,17 say "Variablen-Typ ist bei anderen dBase-Compilern"
  @  9,17 say "nicht  verfgbar,  so  da  dieser Test nicht"
  @ 10,17 say "direkt verglichen werden kann."
  @ 12,17 say "Bitte merken Sie sich den Zeitbedarf fr Ver-"
  @ 13,17 say "gleiche mit anderen Compilern."

  @ 15,17 say "Anfangszeit:"
  @ 16,17 say "Endzeit:"
  @ 18,17 say "Dauer:"

  @ 22,17 say "ESC = Abbruch - andere Taste = Start..."

  repeat
    ch = get_key()
  until ch <> 0
  if ch = &K_ESC
    return
  endif

  @ 22,17 say "Test luft...                          "

  t_anf = time()
  @ 15,30 say t_anf

  for i = 1 to 300000
  next

  t_end = time()
  @ 16,30 say t_end
  @ 18,30 say t_diff(t_anf, t_end)  picture "99999999"
  @ 18,39 say "Sekunden"
  @ 22,17 say "Zurck zum Men mit beliebiger Taste..."
  repeat
  until get_key() <> 0
endpro

procedure schltf                 && Schleifen-Test mit Fliekomma-Zahl

  vardef
    dbl i
    char(8) t_anf, t_end
  enddef

  clear
  @  0, 0 to 24,79 double
  @  2,16 say "FCO Demoprogramm - Schleifentest (Fliekomma)"
  @  3,16 say ""
  @  5,17 say "In  diesem  Programmteil wird eine leere FOR..."
  @  6,17 say "NEXT-Schleife 30.000-mal durchlaufen. Als Zhl-"
  @  7,17 say "variable dient eine Fliekomma-Zahl."
  @  8,17 say "Dieser Variablen-Typ ist auch in anderen dBase-"
  @  9,17 say "Compilern verfgbar,  so da dieser Test direkt"
  @ 10,17 say "verglichen werden kann."
  @ 12,17 say "Bitte  merken  Sie sich den Zeitbedarf fr Ver-"
  @ 13,17 say "gleiche mit anderen Compilern."

  @ 15,17 say "Anfangszeit:"
  @ 16,17 say "Endzeit:"
  @ 18,17 say "Dauer:"

  @ 22,17 say "ESC = Abbruch - andere Taste = Start..."

  repeat
    ch = get_key()
  until ch <> 0
  if ch = &K_ESC
    return
  endif

  @ 22,17 say "Test luft...                          "

  t_anf = time()
  @ 15,30 say t_anf

  for i = 1 to 30000
  next

  t_end = time()
  @ 16,30 say t_end
  @ 18,30 say t_diff(t_anf, t_end) picture "99999999"
  @ 18,39 say "Sekunden"
  @ 22,17 say "Zurck zum Men mit beliebiger Taste..."
  repeat
  until get_key() <> 0
endpro

function dbl tim_to_secs         && Hilfsfunktion fr t_diff()
  parameters const char tim
  return val(substr(tim,1,2)) * 3600 + val(substr(tim,4,2)) * 60 + val(substr(tim,7,2))
endpro

function dbl t_diff              && Zeit-Differenz berechnen
  parameters const char anf, const char end
  return tim_to_secs(end) - tim_to_secs(anf)
endpro

function uint main_menu          && Hauptmen

  vardef
    uint sel
  enddef

  clear
  @  0,0 to 24,79 double
  @  2,24 say    " FCO Demoprogramm - Auswahlmen"
  @  3,24 say    ""
  @  5,24 prompt "1) Schleifen-Test (Ganzzahl)      " id &MSCHLTG
  @  6,24 prompt "2) Schleifen-Test (Fliekommazahl)" id &MSCHLTF
  @  7,24 prompt "3) Datenbank-Test                 " id &MDBTEST
  @  8,24 prompt "4) Index-Test mit UDF             " id &MDBXUDF
  @ 10,24 prompt "X) Programm-Ende                  " id &MQUIT
  menu to sel
  return sel
endpro

procedure title                  && Titelbildschirm

  vardef
    uint x
    long t
  enddef

  clear
  for x = 0 to 11
    @ x, x * 2 to 24 - x, 79 - x * 2 double
    do verzoeg with 5000
  next
  @ 12, 36 say "F  C  O"
  do verzoeg with 100000
endpro

procedure verzoeg                && Zeitverzgerung
  parameters value long l

  vardef
    long i
  enddef

  for i = 1 to l
  next
endpro

procedure dbtest                 && Kombinierter Dateitest
  vardef
    uint i
    char(26) txt
    char(8)  tt_anf, t_anf, t_end
  enddef

  clear
  @  0, 0 to 24,79 double
  @  2,22 say "FCO Demoprogramm - Datenbank-Test"
  @  3,22 say ""
  @  5,17 say "In  diesem  Programmteil wird eine Datei ange-"
  @  6,17 say "legt,  in die 1000  Stze mit der Zeichenfolge"
  @  7,17 say "'ABC...XYZ', 'BCD...YZA' usw. eingetragen wer-"
  @  8,17 say "den.  Anschlieend  wird  noch ein Satz mit 26"
  @  9,17 say "Zeichen 'X'angefgt.  Danach  wird eine Index-"
  @ 10,17 say "Datei angelegt  und abschlieend  der Satz mit"
  @ 11,17 say "26 Zeichen 'X' durch LOCATE aufgesucht."

  @ 13,17 say "Bitte  merken Sie sich den Zeitbedarf fr Ver-"
  @ 14,17 say "gleiche mit anderen Compilern."

  @ 18,17 say "Anfangszeit:"
  @ 19,17 say "Endzeit:"
  @ 20,17 say "Dauer:"
  @ 21,17 say "Gesamtdauer:"

  @ 22,17 say "ESC = Abbruch - andere Taste = Start..."

  repeat
    ch = get_key()
  until ch <> 0
  if ch = &K_ESC
    return
  endif

  @ 23,17 say "Test luft...                          "

  if exist("test.dbf")
    erase "test.dbf"
  endif
  if exist("testx.fdx")
    erase "testx.fdx"
  endif

  @ 17,30 say "Datei anlegen"
  tt_anf = time()
  t_anf  = tt_anf
  @ 18,30 say tt_anf
  build "test.dbf" from alias test

  set alias test  to "test.dbf"
  set alias testx to "testx.fdx"

  use test

  txt = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

  for i = 1 to 1000
    append blank
    replace test->ftext with txt
    txt = substr(txt,2,25) + substr(txt,1,1)
  next

  append blank
  replace test->ftext with replicate("X",26)

  t_end = time()
  @ 19,30 say t_end
  @ 20,30 say t_diff(t_anf, t_end) picture "99999999"

  @ 17,45 say "Index aufbauen"
  t_anf = time()
  @ 18,45 say t_anf

  index "testx.fdx" alias testx
  set index to testx

  t_end = time()
  @ 19,45 say t_end
  @ 20,45 say t_diff(t_anf, t_end) picture "99999999"

  @ 17,60 say "LOCATE ausfhren"
  t_anf = time()
  @ 18,60 say t_anf

  go top
  locate for test->ftext = replicate("X",26)

  t_end = time()
  @ 19,60 say t_end
  @ 20,60 say t_diff(t_anf, t_end) picture "99999999"
  @ 21,60 say t_diff(tt_anf,t_end) picture "99999999"

  @ 23,17 say "Zurck zum Men mit beliebiger Taste..."

  repeat
  until get_key() <> 0
  close databases

endpro

procedure xudftest               && Index-Test mit UDF
  vardef
    uint i
    char(26) txt
    char(8)  tt_anf, t_anf, t_end
  enddef

  clear
  @  0, 0 to 24,79 double
  @  2,20 say "FCO Demoprogramm - Index-Test mit UDF"
  @  3,20 say ""
  @  5,17 say "In  diesem  Programmteil wird eine Datei ange-"
  @  6,17 say "legt,  in die 5000  Stze mit der Zeichenfolge"
  @  7,17 say "'ABC...XYZ', 'BCD...YZA' usw. eingetragen wer-"
  @  8,17 say "den.  Anschlieend  wird  eine Index-Datei mit"
  @  9,17 say "einer eigenen Funktion (UDF) im Index-Ausdruck"
  @ 10,17 say "angelegt."

  @ 12,17 say "Bitte  merken Sie sich den Zeitbedarf fr Ver-"
  @ 13,17 say "gleiche mit anderen Compilern."

  @ 18,17 say "Anfangszeit:"
  @ 19,17 say "Endzeit:"
  @ 20,17 say "Dauer:"
  @ 21,17 say "Gesamtdauer:"

  @ 22,17 say "ESC = Abbruch - andere Taste = Start..."

  repeat
    ch = get_key()
  until ch <> 0
  if ch = &K_ESC
    return
  endif

  @ 23,17 say "Test luft...                          "

  if exist("test.dbf")
    erase "test.dbf"
  endif
  if exist("testx.fdx")
    erase "testx.fdx"
  endif

  @ 17,30 say "Datei anlegen"
  tt_anf = time()
  t_anf  = tt_anf
  @ 18,30 say tt_anf

  build "test.dbf" from alias test

  set alias test  to "test.dbf"
  set alias testu to "testx.fdx"
  use test

  txt = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

  for i = 1 to 5000
    append blank
    replace test->ftext with txt
    txt = substr(txt,2,25) + substr(txt,1,1)
  next

  t_end = time()
  @ 19,30 say t_end
  @ 20,30 say t_diff(t_anf, t_end) picture "99999999"

  @ 17,45 say "Index aufbauen"
  t_anf = time()
  @ 18,45 say t_anf

  index "testx.fdx" alias testu

  t_end = time()
  @ 19,45 say t_end
  @ 20,45 say t_diff(t_anf, t_end) picture "99999999"
  @ 21,45 say t_diff(tt_anf,t_end) picture "99999999"

  @ 23,17 say "Zurck zum Men mit beliebiger Taste..."

  repeat
  until get_key() <> 0

  close databases

endpro

function char(26) cap_first      && UDF fr Index-Test
  parameters const char(26) txt
  return upper(substr(txt,1,1)) + substr(txt,2,len(txt)-1)
endpro

*** EOF ***
