/*
Ŀ
                                                                          
                            TSDWIN.CH                                     
                                                                          
                    Source File for TSDWIN.LIB                            
                   Clipper 5.0 Interface Library                          
                                                                          
      Copyright ( C ) 1992 by Trilateral Systems Development Ltd.         
    All Rights Reserved * Version 2.10 * Release Date: Dec 20, 1992       
                                                                          
                         18  Bond St. South                               
                         Dundas, ON, Canada                               
                              L9H 3H1                                     
                           416-628-5086                                   
                                                                          
                                                                          
     Documented: 12-12-92      at 12:27:37pm                              

*/
#define TSD_HSEP        ""
#define TSD_CSEP        "  "
#define TSD_FSEP        ""

#define RSHIFT          01 //      1       0x0001
#define LSHIFT          02 //      2       0x0002
#define CTRL            03 //      4       0x0004
#define ALT             04 //      8       0x0008
#define SCROLLSTAT      05 //     16       0x0010
#define NUMLOCKSTAT     06 //     32       0x0020
#define CAPLOCKSTAT     07 //     64       0x0040
#define INSERTSTAT      08 //    128       0x0080
#define CTRLNUMLKSTAT   09 //   2048       0x0800
#define SCROLLOCK       10 //   4096       0x1000
#define NUMLOCK         11 //   8192       0x2000
#define CAPLOCK         12 //  16384       0x4000
#define INSERT          13 //  32768       0x8000

#define TRUE            .T.
#define YES             .T.

#define FALSE           .F.
#define NO              .F.

#define MACOMP(cexpr)   &("{||" + cexpr + "}")

#ifdef DEBUG
    #define ASSERT(expl, func) IIF(expl, "", func(procline()))
#else
    #define ASSERT(expl, func)
#endif

#define LOG10( num )    LOG( num ) / LOG( 10 )
/*

 Useful Translates

*/
#translate STRINT(<x>)     => LTRIM(STR(INT(<x>)))
#translate STRNUM(<x>)     => LTRIM(STR(<x>))
#translate ISNIL( <v1> )   => ( <v1> == NIL )
#translate ISARR( <v1> )   => ( VALTYPE(<v1>) == "A" )
#translate ISBLK( <v1> )   => ( VALTYPE(<v1>) == "B" )
#translate ISCHAR( <v1> )  => ( VALTYPE(<v1>) == "C" )
#translate ISDATE( <v1> )  => ( VALTYPE(<v1>) == "D" )
#translate ISLOGI( <v1> )  => ( VALTYPE(<v1>) == "L" )
#translate ISMEMO( <v1> )  => ( VALTYPE(<v1>) == "M" )
#translate ISNUM( <v1> )   => ( VALTYPE(<v1>) == "N" )
#translate ISOBJ( <v1> )   => ( VALTYPE(<v1>) == "O" )

/*

 Useful Commands

*/
#command ASHRINK( <array>, <size> ) ;
         => ;
         ASIZE( <array>, IIF( <size>  == NIL, LEN( <array> ) - 1, <size> ))

#command AEXPAND( <array>, <number> ) ;
         => ;
         ASIZE( <array>, IIF( <number> == NIL, 1, <number> ))

#command REPEAT => DO WHILE .T.
#command UNTIL <lexp> => IF (<lexp>); EXIT; END; END

#command DEFAULT <p> TO <val> [,<pn> TO <valn>] ;
         => ;
         <p> := IIF(<p> == NIL, <val>, <p>) ;
         [;<pn> := IIF(<pn> == NIL, <valn>, <pn>)]
/*

 Window Constants

*/
#define WINTOP            _twTop()
#define WINLEFT           _twLeft()
#define WINBOTTOM         _twBottom()
#define WINRIGHT          _twRight()
#define WINLENGTH         _twBottom()-_twTop()+1
#define WINWIDTH          _twRight()-_twLeft()+1
#define WINHANDLE         _twHandle()
#define WINSHADOW         _twShadow()
#define WINTHICK          _twShTh()
#define WINSTRUCT         _twStructure()
#define WINTITLE          _twTitle()
#define WINCOLOR          _twColor()
#define WINFCOLOR         _twFcolor()
#define WINFRAME          _twFrame()
#define WINNAME           _twName()
#define WINHIDE           _twHide()
#define WINNEXT           _twNext()
#define WINPREV           _twPrev()
#define WINCARGO          _twCargo()
#define WINSTRUC          _twStructure( nHandle )
#define GETSTACK          _twArray()
#define EXPLODEON         twExplode( .T. )
#define EXPLODEOFF        twExplode( .F. )
/*

 window cargo defines

*/
#define WC_SIZE     1
#define WC_GETLIST  2
#define WC_BROWSE   3
#define WC_PROMPTS  4
/*

 Scroll Bar Constants

*/
#define SB_ROWTOP         1
#define SB_COLTOP         2
#define SB_ROWBOTTOM      3
#define SB_COLBOTTOM      4
#define SB_COLOR          5
#define SB_POSITION       6
#define SB_DIRECTION      7
#define SB_MOUSEID        8

#define SB_ELEMENTS       8  // The number of elements defining a scroll bar
                             // data structure
#define SB_UPARROW        CHR(  24 )
#define SB_DNARROW        CHR(  25 )  // The Up and Down arrows,
#define SB_LEFTARROW      CHR(  27 )  // highlight and background
#define SB_RIGHTARROW     CHR(  26 )  // char's for the thumb tab
#define SB_HIGHLIGHT      CHR( 219 )
#define SB_BACKGROUND     CHR( 176 )

#define SB_HORIZONTAL     1  // Directions for scroll bars
#define SB_VERTICAL       2

#define MHIDE             IIF( lOKMouse, _twM2(), .T. )
#define MSHOW             IIF( lOKMouse, _twM1(), .T. )
#define MOKSHOW           IIF(( lOKMouse := twOKMouse() ), _twM1(), .T. )

/*

 Window Oriented Commands

*/
#command  WINDOW ;
          => ;
          twOpen()

#command  CREATEWINDOW ;
          => ;
          twNew()

#command  WINDOW TO <nHandle>;
          => ;
          <nHandle> := twOpen()

#command  CREATEWINDOW TO <nHandle>;
          => ;
          <nHandle> := twNew()

#command  WINDOW AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                    [COLOR <cColor>]                             ;
                    [SHADOW <nShadow>]                           ;
                    [FRAME <nFrame>]                             ;
                    [FILL <cFill>]                               ;
                    [FCOLOR <cFColor>]                           ;
                    [TITLE <cTitle>]                             ;
          => ;
          twOpen( <nTop>, <nLeft>, <nBottom>, <nRight>, <cColor>, ;
                  <nShadow>, <nFrame>, <cFill>, <cFColor>, <cTitle> )

#command  CREATEWINDOW AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                    [COLOR <cColor>]                                   ;
                    [SHADOW <nShadow>]                                 ;
                    [FRAME <nFrame>]                                   ;
                    [FILL <cFill>]                                     ;
                    [FCOLOR <cFColor>]                                 ;
                    [TITLE <cTitle>]                                   ;
          => ;
          twNew( <nTop>, <nLeft>, <nBottom>, <nRight>, <cColor>, ;
                 <nShadow>, <nFrame>, <cFill>, <cFColor>, <cTitle> )

#command  WINDOW TO <nHandle> AT                                 ;
                    [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                    [COLOR <cColor>]                             ;
                    [SHADOW <nShadow>]                           ;
                    [FRAME <nFrame>]                             ;
                    [FILL <cFill>]                               ;
                    [FCOLOR <cFColor>]                           ;
                    [TITLE <cTitle>]                             ;
          => ;
          <nHandle> := twOpen( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
                               <cColor>, <nShadow>, <nFrame>, <cFill>,;
                               <cFColor>, <cTitle> )

#command  CREATEWINDOW TO <nHandle> AT                           ;
                    [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                    [COLOR <cColor>]                             ;
                    [SHADOW <nShadow>]                           ;
                    [FRAME <nFrame>]                             ;
                    [FILL <cFill>]                               ;
                    [FCOLOR <cFColor>]                           ;
                    [TITLE <cTitle>]                             ;
          => ;
          <nHandle> := twNew( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
                              <cColor>, <nShadow>, <nFrame>, <cFill>, ;
                              <cFColor>, <cTitle> )

#xcommand  WINSHOW <nHandle> => twShow( <nHandle> )

#xcommand  WINPOP => twPop()

#xcommand  WINCLOSE <nHandle> => twClose( <nHandle> )

#xcommand  WINHIDE <nHandle > => twHide( <nHandle> )

#xcommand  WINUNHIDE <nHandle> => twUnHide( <nHandle> )

#xcommand  WINACTIVATE <nHandle> => twActivate( <nHandle> )

#xcommand  WINDISPLAY <nHandle> =>  twDisplay( <nHandle> )

#xcommand  WINHEADER <*cTitle*> [COLOR <cColor>] [JUSTIFY <cJust>] ;
                     [DELIM <cDelim>] [HANDLE <nHandle>];
          =>;
          twTitle( #<cTitle>, <cColor>,, <cJust>, <cDelim>, <nHandle> )

#xcommand  WINFOOTER <*cTitle*> [COLOR <cColor>] [JUSTIFY <cJust>] ;
                     [DELIM <cDelim>] [HANDLE <nHandle>] ;
          =>;
          twTitle( #<cTitle>,<cColor>, "B", <cJust>, <cDelim>, <nHandle> )

#xcommand  WINBORDER [FRAME <nFrame>] [COLOR <cColor>] [HANDLE <nHandle>];
                     [TITLES <lTitle>];
          =>;
          twFrame( <nFrame>, <cColor>, <nHandle>, <lTitle> )

#xcommand  WINBOX <nTop>, <nLeft>, <nBottom>, <nRight>;
                  TYPE <nType> [COLOR <cColor>];
                  [SHADOW <nShadow>] [FILL <cFill>] ;
                  [ABSOLUTE <lAbs>]  [HANDLE <nHandle>] ;
                  [TOSCREEN <lToScreen>];
           => ;
           twBox( <nTop>, <nLeft>, <nBottom>, <nRight>, <nType>, ;
                  <cColor>, <cFill>, <lAbs>, <nShadow>, ;
                  <nHandle>, <lToScreen> )

#xcommand  WINBUTTON <nTop>, <nLeft> PROMPT <cButton>;
                     [PAD <lPad>] [COLOR <cColor>] [SHADOW <nShadow>];
           => ;
           twCreateButton( <nTop>, <nLeft>, <cButton>, <lPad>, ;
                           <cColor>, <nShadow> )

#xcommand  CLEARWITH <cPattern>, [<nTop>], [<nLeft>], [<nBottom>], ;
                     [<nRight>] [BORDER <lBorder>] [COLOR <cAttr>];
           => ;
           twClearWith( <lBorder>, <cPattern>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <cAttr> )

#xcommand  WINCLEAR  [<nTop>], [<nLeft>], [<nBottom>], [<nRight>];
                     [BORDER <lBorder>] [FILL <cFill>];
                     [HANDLE <nHandle>] [TOSCREEN <lToScreen>];
           => ;
           twClear( <lBorder>, <cFill>, <nTop>, <nLeft>, <nBottom>, ;
                    <nRight>, <nHandle>, <lToScreen> )

#xcommand  WINCLEARLINE  <nRow> [BORDER <lBorder>] [COLOR <cAttr>];
                         [HANDLE <nHandle>] [TOSCREEN <lToScreen>];
           => ;
           twClearLine( <nRow>, <lBorder>, <cAttr>, <nHandle>, <lToScreen> )

#xcommand  WINATTRIBUTE [<nTop>], [<nLeft>], [<nBottom>], [<nRight>];
                        [BORDER <lBorder>] [COLOR <cColor>];
                        [HANDLE <nHandle>] [TOSCREEN <lToScreen>];
           => ;
           twAttrib( <lBorder>, <cColor>, <nTop>, <nLeft>, <nBottom>, ;
                     <nRight>, <nHandle>, <lToScreen> )

#xcommand  WINHLINE <nRow>, <nCol> LENGTH <Length> TYPE <nType> ;
                    [COLOR <cColor>] [HANDLE <nHandle>] ;
                    [TOSCREEN <lToScreen>] ;
           => ;
           twHLine( <nRow>, <nCol>, <Length>, <nType>, <cColor>, ;
                    <nHandle>, <lToScreen> )

#xcommand  WINVLINE <nRow>, <nCol> LENGTH <Length> TYPE <nType> ;
                    [COLOR <cColor>] [HANDLE <nHandle>] ;
                    [TOSCREEN <lToScreen>] ;
           => ;
           twVLine( <nRow>, <nCol>, <Length>, <nType>, <cColor>, ;
                    <nHandle>, <lToScreen> )

#xcommand  WINSAY <xOutput> AT <nRow>, <nCol> [COLOR <cAttr>];
                  [PICTURE <cPicture>] [HANDLE <nHandle>] ;
                  [TOSCREEN <lToScreen>] [YESNO <lYesNo>];
           => ;
           twSay( <nRow>, <nCol>, <xOutput>, <cAttr>, <cPicture>, ;
                  <nHandle>, <lYesNo>, <lToScreen> )

#xcommand  WINSAY2 <cString> AT <nRow>, <nCol> [COLOR <cAttr>];
                   [HANDLE <nHandle>] [TOSCREEN <lToScreen>] ;
           => ;
           twSay2( <nRow>, <nCol>, <cString>, <cAttr>, ;
                   <nHandle>, <lToScreen> )

#xcommand  WINSAYARRAY <aStrings> AT <nRow>, <nCol> [COLOR <cAttr>];
                       [ROWSKIP <nRowSkip>];
                       [HANDLE <nHandle>] [TOSCREEN <lToScreen>] ;
           => ;
           twASay( <aStrings>, <nRow>, <nCol>, <cAttr>,;
                   <nRowSkip>, <nHandle>, <lToScreen> )


#xcommand  WINCENTER <xOutput> AT <nRow> [COLOR <cAttr>] ;
                     [PICTURE <cPicture>] [HANDLE <nHandle>] ;
                     [TOSCREEN <lToScreen>] [YESNO <lYesNo>];
           => ;
           twCenter( <nRow>, <xOutput>, <cAttr>, <cPicture>, ;
                     <nHandle>, <lYesNo>, <lToScreen> )

#xcommand  WINCENTRE <xOutput> AT <nRow> [COLOR <cAttr>] ;
                     [PICTURE <cPicture>] [HANDLE <nHandle>] ;
                     [TOSCREEN <lToScreen>] [YESNO <lYesNo>];
           => ;
           twCenter( <nRow>, <xOutput>, <cAttr>, <cPicture>, ;
                     <nHandle>, <lYesNo>, <lToScreen> )

#xcommand  WINLEFT <xOutput> AT <nRow> [COLOR <cAttr>] ;
                   [PICTURE <cPicture>] [HANDLE <nHandle>] ;
                   [TOSCREEN <lToScreen>] [YESNO <lYesNo>];
           => ;
           twLeft( <nRow>, <xOutput>, <cAttr>, <cPicture>, ;
                   <nHandle>, <lYesNo>, <lToScreen> )

#xcommand  WINRIGHT <xOutput> AT <nRow> [COLOR <cAttr>] ;
                    [PICTURE <cPicture>] [HANDLE <nHandle>] ;
                    [TOSCREEN <lToScreen>] [YESNO <lYesNo>];
           => ;
           twRight( <nRow>, <xOutput>, <cAttr>, <cPicture>, ;
                    <nHandle>, <lYesNo>, <lToScreen> )

#xcommand  WINTYPE <cString> AT <nRow>, <nCol> ;
                   [COLOR <cAttr>] [SOUND <lSound>];
           => ;
           twType( <nRow>, <nCol>, <cString>, <cAttr>, <lSound> )

#xcommand  STRINGSLIDE <cString> AT <nRow>, <nCol> ;
                        DIRECTION <cDirection> [COLOR <cColor>];
                        [DELAY <nDelay>];
           => ;
           twStrSlide( <cDirection>, <nRow>, <nCol>, <cString>, ;
                       <cColor>, <nDelay> )

#xcommand  WINMOVE [VERT <nVert>] [HORIZ <nHorz>] [HANDLE <nHandle>];
           => ;
           twMove( <nVert>, <nHorz>, <nHandle> )

#xcommand  WINSIZE DIRECTION <cDirection> [NUMBER <nNum2Size>];
                   [CONTINUOUS <lContinuous>];
           => ;
           twSize( <cDirection>, <nNum2Size>,, <lContinuous> )

#xcommand  WINSLIDE DIRECTION <cDirection> [NUMBER <nNumber>];
                    [SHADOW <lShadow>];
           => ;
           twSlide( <cDirection>, <nNumber>, <lShadow> )
/*

 Menu and SAY.. GET.. Commands

*/
#command  @ <row>, <col> WSAY <cexpr> [COLOR <cColor>] [PICTURE <picture>];
          => ;
          twSay( <row>, <col>, <cexpr>, <cColor>, <picture> )

#command @ <row>, <col> WPROMPT <prompt> [MESSAGE <msg>] [COLOR <cColor>] ;
        [WHEN <when>] [ACTION <action>];
        =>;
        IIF( aMenu == NIL, aMenu := {}, NIL )            ;
        ;AADD( aMenu, { twRow( <row> ), twCol( <col> ), <prompt>, ;
                        <msg>, <cColor>, <{when}>, <{action}> })

#ifdef NOMOUSE

    #command WMENU TO <v> [HELPVAR <cHelpVar>] [HELPLEVEL <nHelpLevel>] ;
        => <v> := ntwMenuTo( {|_1| if(PCount() == 0, <v>, <v> := _1)},  ;
                             #<v>, aMenu, #<cHelpVar>, <nHelpLevel> )        ;
            ;aMenu := {}

#else

    #command WMENU TO <v> [HELPVAR <cHelpVar>] [HELPLEVEL <nHelpLevel>] ;
        => <v> := twMenuTo( {|_1| if(PCount() == 0, <v>, <v> := _1)},   ;
                            #<v>, aMenu, #<cHelpVar>, <nHelpLevel> )         ;
            ;aMenu := {}

#endif
/*

 Message Systems Commands

*/
#ifdef NOMOUSE
    /*
    
     Area Messages
    
    */

    #command  WARNLINE <InMsg> [WAIT <nWait>] ;
                       [JUSTIFY <cJust>]      ;
                       [LINE    <nLine>]      ;
              => ;
              ntwWarnLine( <nWait>, <InMsg>, <cJust>, <nLine> )

    #command  INFOLINE <InMsg> [WAIT <nWait>] ;
                       [JUSTIFY <cJust>]      ;
                       [LINE    <nLine>]      ;
              => ;
              ntwInfoLine( <nWait>, <InMsg>, <cJust>, <nLine> )

    #command  POPLINE => ntwAMPop()
    /*
    
     Boxed Messages
    
    */
    #command INFORM <cMessage>               ;
                    [HEADER    <cHeader>]    ;
                    [WAIT      <nWait>]      ;
                    [TOP       <nTop>]       ;
                    [LEFT      <nLeft>]      ;
                    [SHADOW    <nShadow>]    ;
                    [FRAME     <nFrame>]     ;
                    [HELPVAR   <cHelpVar>]   ;
                    [HELPLEVEL <nHelpLevel>] ;
            => ;
            ntwInfo( <cMessage>, <cHeader>, <nWait>, <nTop>, <nLeft>, ;
                    <nShadow>, <nFrame>, <cHelpVar>, <nHelpLevel> )

    #command INQUIRE <cMessage> TO <getvar>   ;
                     [HEADER <cHeader>]       ;
                     [TOP <nTop>]             ;
                     [LEFT <nLeft>]           ;
                     [SHADOW <nShadow>]       ;
                     [FRAME <nFrame>]         ;
                     [PICTURE <cPicture>]     ;
                     [HELPVAR <cHelpVar>]     ;
                     [HELPLEVEL <nHelpLevel>] ;
            => ;
            <getvar> := ntwInquire( <cMessage>, <cHeader>, <getvar>, ;
                                    <nTop>,<nLeft>, <nShadow>, ;
                                    <nFrame>, <cPicture>, <cHelpVar>, ;
                                    <nHelpLevel> )

    #command WARNING <cMessage> [HEADER <cHeader>] ;
                     [WAIT <nWait>]                ;
                     [TOP <nTop>]                  ;
                     [LEFT <nLeft>]                ;
                     [SHADOW <nShadow>]            ;
                     [FRAME <nFrame>]              ;
                     [HELPVAR <cHelpVar>]          ;
                     [HELPLEVEL <nHelpLevel>]      ;
            => ;
            ntwWarn( <cMessage>, <cHeader>, <nWait>, <nTop>, <nLeft>, ;
                    <nShadow>, <nFrame>, <cHelpVar>, <nHelpLevel> )

    #command MSGTEXT <cMessage>               ;
                     [HEADER <cHeader>]       ;
                     [WAIT <nWait>]           ;
                     [<nTop>], [<nLeft>],     ;
                     [<nBottom>], [<nRight>]  ;
                     [COLOR <cColor>]         ;
                     [SHADOW <nShadow>]       ;
                     [FRAME <nFrame>]         ;
                     [FOOTER <cFooter>]       ;
                     [PRERUN <bPreRun>]       ;
                     [HELPVAR <cHelpVar>]     ;
                     [HELPLEVEL <nHelpLevel>] ;
            => ;
            ntwTextMsg( <cMessage>, <cHeader>, <nWait>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <cColor>, <nShadow>, ;
                        <nFrame>, <cFooter>, <bPreRun>, <cHelpVar>, ;
                        <nHelpLevel> )

    #command POPMSG => ntwMPop()
    /*
    
     Alert System Commands
    
    */
    #command BUTTONBOX [<orient:H,V>] TO <xVar>                        ;
                       [MESSAGE    <cMessage>]                         ;
                       [TITLE      <cTitle>]                           ;
                       [WITH <nButtons> BUTTONS]                       ;
                       [CHOICES    <aChoices>]                         ;
                       [START      <nStart>]                           ;
                       AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                       [SHADOW     <nShadow>]                          ;
                       [FRAME      <nFrame>]                           ;
                       [EXITKEY    <xExitKey>]                         ;
                       [ACTIONKEYS <aActionKeys>]                      ;
                       [PRERUN     <bPreRun>]                          ;
                       [POSTRUN    <bPostRun>]                         ;
                       [HELPVAR    <cHelpVar>]                         ;
                       [HELPLEVEL  <nHelpLevel>]                       ;
            => ;
            <xVar> := ntwButtonBox( <"orient">, <cMessage>, <cTitle>, ;
                           <nButtons>, <aChoices>, <nStart>, <nTop>, ;
                           <nLeft>, <nBottom>, <nRight>, <nShadow>, ;
                           <nFrame>, <xExitKey>, <aActionKeys>,;
                           <bPreRun>, <bPostRun>, <cHelpVar>, <nHelpLevel> )

    #command CHECKBOX [<orient:H,V>] TO <xVar>                        ;
                      [MESSAGE    <cMessage>]                         ;
                      [TITLE      <cTitle>]                           ;
                      [WITH <nButtons> BUTTONS]                       ;
                      [CHOICES    <aChoices>]                         ;
                      [START      <nStart>]                           ;
                      AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                      [SHADOW     <nShadow>]                          ;
                      [FRAME      <nFrame>]                           ;
                      [EXITKEY    <xExitKey>]                         ;
                      [ACTIONKEYS <aActionKeys>]                      ;
                      [PRERUN     <bPreRun>]                          ;
                      [POSTRUN    <bPostRun>]                         ;
                      [HELPVAR    <cHelpVar>]                         ;
                      [HELPLEVEL  <nHelpLevel>]                       ;
            => ;
            <xVar> := ntwCheckBox( <"orient">, <cMessage>, <cTitle>, ;
                        <nButtons>, <aChoices>, <nStart>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <nShadow>, <nFrame>, ;
                        <xExitKey>, <aActionKeys>, <bPreRun>, <bPostRun>, ;
                        <cHelpVar>, <nHelpLevel> )

    #command RADIOBOX [<orient:H,V>] TO <xVar>                        ;
                      [MESSAGE    <cMessage>]                         ;
                      [TITLE      <cTitle>]                           ;
                      [WITH <nButtons> BUTTONS]                       ;
                      [CHOICES    <aChoices>]                         ;
                      [START      <nStart>]                           ;
                      AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                      [SHADOW     <nShadow>]                          ;
                      [FRAME      <nFrame>]                           ;
                      [EXITKEY    <xExitKey>]                         ;
                      [ACTIONKEYS <aActionKeys>]                      ;
                      [PRERUN     <bPreRun>]                          ;
                      [POSTRUN    <bPostRun>]                         ;
                      [HELPVAR    <cHelpVar>]                         ;
                      [HELPLEVEL  <nHelpLevel>]                       ;
            => ;
            <xVar> := ntwRadioBox( <"orient">, <cMessage>, <cTitle>, ;
                        <nButtons>, <aChoices>, <nStart>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <nShadow>, <nFrame>, <xExitKey>,;
                        <aActionKeys>, <bPreRun>, <bPostRun>, <cHelpVar>, ;
                        <nHelpLevel> )
#else
    /*
    
     Area Messages
    
    */

    #command  WARNLINE <InMsg> [WAIT <nWait>] ;
                       [JUSTIFY <cJust>]      ;
                       [LINE    <nLine>]      ;
              => ;
              twWarnLine( <nWait>, <InMsg>, <cJust>, <nLine> )

    #command  INFOLINE <InMsg> [WAIT <nWait>] ;
                       [JUSTIFY <cJust>]      ;
                       [LINE    <nLine>]      ;
              => ;
              twInfoLine( <nWait>, <InMsg>, <cJust>, <nLine> )

    #command  POPLINE => twAMPop()
    /*
    
     Boxed Messages
    
    */
    #command INFORM <cMessage>               ;
                    [HEADER    <cHeader>]    ;
                    [WAIT      <nWait>]      ;
                    [TOP       <nTop>]       ;
                    [LEFT      <nLeft>]      ;
                    [SHADOW    <nShadow>]    ;
                    [FRAME     <nFrame>]     ;
                    [HELPVAR   <cHelpVar>]   ;
                    [HELPLEVEL <nHelpLevel>] ;
            => ;
            twInfo( <cMessage>, <cHeader>, <nWait>, <nTop>, <nLeft>, ;
                    <nShadow>, <nFrame>, <cHelpVar>, <nHelpLevel> )

    #command INQUIRE <cMessage> TO <getvar>   ;
                     [HEADER <cHeader>]       ;
                     [TOP <nTop>]             ;
                     [LEFT <nLeft>]           ;
                     [SHADOW <nShadow>]       ;
                     [FRAME <nFrame>]         ;
                     [PICTURE <cPicture>]     ;
                     [HELPVAR <cHelpVar>]     ;
                     [HELPLEVEL <nHelpLevel>] ;
            => ;
            <getvar> := twInquire( <cMessage>, <cHeader>, <getvar>, ;
                                    <nTop>,<nLeft>, <nShadow>, ;
                                    <nFrame>, <cPicture>, <cHelpVar>, ;
                                    <nHelpLevel> )

    #command WARNING <cMessage> [HEADER <cHeader>] ;
                     [WAIT <nWait>]                ;
                     [TOP <nTop>]                  ;
                     [LEFT <nLeft>]                ;
                     [SHADOW <nShadow>]            ;
                     [FRAME <nFrame>]              ;
                     [HELPVAR <cHelpVar>]          ;
                     [HELPLEVEL <nHelpLevel>]      ;
            => ;
            twWarn( <cMessage>, <cHeader>, <nWait>, <nTop>, <nLeft>, ;
                    <nShadow>, <nFrame>, <cHelpVar>, <nHelpLevel> )

    #command MSGTEXT <cMessage>               ;
                     [HEADER <cHeader>]       ;
                     [WAIT <nWait>]           ;
                     [<nTop>], [<nLeft>],     ;
                     [<nBottom>], [<nRight>]  ;
                     [COLOR <cColor>]         ;
                     [SHADOW <nShadow>]       ;
                     [FRAME <nFrame>]         ;
                     [FOOTER <cFooter>]       ;
                     [PRERUN <bPreRun>]       ;
                     [HELPVAR <cHelpVar>]     ;
                     [HELPLEVEL <nHelpLevel>] ;
            => ;
            twTextMsg( <cMessage>, <cHeader>, <nWait>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <cColor>, <nShadow>, ;
                        <nFrame>, <cFooter>, <bPreRun>, <cHelpVar>, ;
                        <nHelpLevel> )

    #command POPMSG => twMPop()
    /*
    
     Alert System Commands
    
    */
    #command BUTTONBOX [<orient:H,V>] TO <xVar>                        ;
                       [MESSAGE    <cMessage>]                         ;
                       [TITLE      <cTitle>]                           ;
                       [WITH <nButtons> BUTTONS]                       ;
                       [CHOICES    <aChoices>]                         ;
                       [START      <nStart>]                           ;
                       AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                       [SHADOW     <nShadow>]                          ;
                       [FRAME      <nFrame>]                           ;
                       [EXITKEY    <xExitKey>]                         ;
                       [ACTIONKEYS <aActionKeys>]                      ;
                       [PRERUN     <bPreRun>]                          ;
                       [POSTRUN    <bPostRun>]                         ;
                       [HELPVAR    <cHelpVar>]                         ;
                       [HELPLEVEL  <nHelpLevel>]                       ;
            => ;
            <xVar> := twButtonBox( <"orient">, <cMessage>, <cTitle>, ;
                           <nButtons>, <aChoices>, <nStart>, <nTop>, ;
                           <nLeft>, <nBottom>, <nRight>, <nShadow>, ;
                           <nFrame>, <xExitKey>, <aActionKeys>,;
                           <bPreRun>, <bPostRun>, <cHelpVar>, <nHelpLevel> )

    #command CHECKBOX [<orient:H,V>] TO <xVar>                        ;
                      [MESSAGE    <cMessage>]                         ;
                      [TITLE      <cTitle>]                           ;
                      [WITH <nButtons> BUTTONS]                       ;
                      [CHOICES    <aChoices>]                         ;
                      [START      <nStart>]                           ;
                      AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                      [SHADOW     <nShadow>]                          ;
                      [FRAME      <nFrame>]                           ;
                      [EXITKEY    <xExitKey>]                         ;
                      [ACTIONKEYS <aActionKeys>]                      ;
                      [PRERUN     <bPreRun>]                          ;
                      [POSTRUN    <bPostRun>]                         ;
                      [HELPVAR    <cHelpVar>]                         ;
                      [HELPLEVEL  <nHelpLevel>]                       ;
            => ;
            <xVar> := twCheckBox( <"orient">, <cMessage>, <cTitle>, ;
                        <nButtons>, <aChoices>, <nStart>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <nShadow>, <nFrame>, ;
                        <xExitKey>, <aActionKeys>, <bPreRun>, <bPostRun>, ;
                        <cHelpVar>, <nHelpLevel> )

    #command RADIOBOX [<orient:H,V>] TO <xVar>                        ;
                      [MESSAGE    <cMessage>]                         ;
                      [TITLE      <cTitle>]                           ;
                      [WITH <nButtons> BUTTONS]                       ;
                      [CHOICES    <aChoices>]                         ;
                      [START      <nStart>]                           ;
                      AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                      [SHADOW     <nShadow>]                          ;
                      [FRAME      <nFrame>]                           ;
                      [EXITKEY    <xExitKey>]                         ;
                      [ACTIONKEYS <aActionKeys>]                      ;
                      [PRERUN     <bPreRun>]                          ;
                      [POSTRUN    <bPostRun>]                         ;
                      [HELPVAR    <cHelpVar>]                         ;
                      [HELPLEVEL  <nHelpLevel>]                       ;
            => ;
            <xVar> := twRadioBox( <"orient">, <cMessage>, <cTitle>, ;
                        <nButtons>, <aChoices>, <nStart>, <nTop>, <nLeft>, ;
                        <nBottom>, <nRight>, <nShadow>, <nFrame>, <xExitKey>,;
                        <aActionKeys>, <bPreRun>, <bPostRun>, <cHelpVar>, ;
                        <nHelpLevel> )
#endif
/*

 Browse System Commands

*/
#command BROWSEARRAY <array>                                         ;
                     AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                     [TITLE      <cTitle>]                           ;
                     [HEADERS    <headers>]                          ;
                     [FOOTERS    <footers>]                          ;
                     [EDIT       <lEdit>]                            ;
                     [ACTIONKEYS <aActionKeys>]                      ;
                     [COLOR      <cColor>]                           ;
                     [SHADOW     <nShadow>]                          ;
                     [FRAME      <nFrame>]                           ;
                     [FRAMECOLOR <cFColor>]                          ;
                     [AUTOLITE   <lAutoLite>]                        ;
                     [FREEZE     <nFreeze>]                          ;
                     [HELPVAR    <cHelpVar>]                         ;
                     [HELPLEVEL  <nHelpLevel>]                       ;
         => ;
         twArBrowse( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
                     <array> , <cTitle>, <headers>, <footers>, ;
                     <lEdit>, <aActionKeys>, <cColor>, <nShadow>, ;
                     <nFrame>, <cFColor>, <lAutoLite>, <nFreeze>, ;
                     <cHelpVar>, <nHelpLevel> )

#command BROWSEARRAY <array> TO <xVar>                               ;
                     AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                     [TITLE      <cTitle>]                           ;
                     [HEADERS    <headers>]                          ;
                     [FOOTERS    <footers>]                          ;
                     [EDIT       <lEdit>]                            ;
                     [ACTIONKEYS <aActionKeys>]                      ;
                     [COLOR      <cColor>]                           ;
                     [SHADOW     <nShadow>]                          ;
                     [FRAME      <nFrame>]                           ;
                     [FRAMECOLOR <cFColor>]                          ;
                     [AUTOLITE   <lAutoLite>]                        ;
                     [FREEZE     <nFreeze>]                          ;
                     [HELPVAR    <cHelpVar>]                         ;
                     [HELPLEVEL  <nHelpLevel>]                       ;
         => ;
         <xVar> := twArBrowse( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
                      <array> , <cTitle>, <headers>, <footers>, ;
                      <lEdit>, <aActionKeys>, <cColor>, <nShadow>, ;
                      <nFrame>, <cFColor>, ;
                      <lAutoLite>, <nFreeze>, <cHelpVar>, <nHelpLevel> )

#command BROWSEDBF AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                   [COLUMNS     <aColumns>]                        ;
                   [TITLE       <cTitle>]                          ;
                   [FOOTERS     <footers>]                         ;
                   [TOPBLOCK    <bTopBlock>]                       ;
                   [BOTTOMBLOCK <bBotBlock>]                       ;
                   [SCOPEBLOCK  <bScopelock>]                      ;
                   [EDIT        <lEdit>]                           ;
                   [ACTIONKEYS  <aActionKeys>]                     ;
                   [COLOR       <cColor>]                          ;
                   [SHADOW       <nShadow>]                        ;
                   [FRAME       <nFrame>]                          ;
                   [FRAMECOLOR  <cFColor>]                         ;
                   [SCROLLBAR   <scrollbar>]                       ;
                   [MESSAGES    <messages>]                        ;
                   [AUTOLITE    <lAutoLite>]                       ;
                   [FREEZE      <nFreeze>]                         ;
                   [STABILIZE   <stabilize>]                       ;
                   [HELPVAR     <cHelpVar>]                        ;
                   [HELPLEVEL   <nHelpLevel>]                      ;
         => ;
         twDBrowse( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
            <aColumns>, <cTitle>, <footers>, <bTopBlock>, ;
            <bBotBlock>, <bScopelock>, <lEdit>, <aActionKeys>, ;
            <cColor>, <nShadow>, <nFrame>, <cFColor>, <scrollbar>, ;
            <messages>, <lAutoLite>, <nFreeze>, <stabilize>, ;
            <cHelpVar>, <nHelpLevel> )

#command BROWSEDBF TO <xVar>                                       ;
                   AT [<nTop>], [<nLeft>], [<nBottom>], [<nRight>] ;
                   [COLUMNS     <aColumns>]                        ;
                   [TITLE       <cTitle>]                          ;
                   [FOOTERS     <footers>]                         ;
                   [TOPBLOCK    <bTopBlock>]                       ;
                   [BOTTOMBLOCK <bBotBlock>]                       ;
                   [SCOPEBLOCK  <bScopelock>]                      ;
                   [EDIT        <lEdit>]                           ;
                   [ACTIONKEYS  <aActionKeys>]                     ;
                   [COLOR       <cColor>]                          ;
                   [SHADOW      <nShadow>]                         ;
                   [FRAME       <nFrame>]                          ;
                   [FRAMECOLOR  <cFColor>]                         ;
                   [SCROLLBAR   <scrollbar>]                       ;
                   [MESSAGES    <messages>]                        ;
                   [AUTOLTE     <autolte>]                         ;
                   [FREEZE      <nFreeze>]                         ;
                   [STABILIZE   <stabilize>]                       ;
                   [HELPVAR     <cHelpVar>]                        ;
                   [HELPLEVEL   <nHelpLevel>]                      ;
         => ;
         <xVar> := twDBrowse( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
                      <aColumns>, <cTitle>, <footers>, <bTopBlock>, ;
                      <bBotBlock>, <bScopelock>, <lEdit>, <aActionKeys>, ;
                      <cColor>, <nShadow>, <nFrame>, <cFColor>, ;
                      <scrollbar>, <messages>, <autolte>, ;
                      <nFreeze>, <stabilize>, <cHelpVar>, <nHelpLevel> )
/*
Ŀ
 Program Name  TsdUdc01.ch                                           
 Version       1.0 (Clipper 5.01)                                    
 Copyright     Trilateral Systems Development Ltd.                   
 Author        James O. Bohanan Jr. / B-Three Information Systems.   
 Date          10/26/92                                              

//  Memo Edit Function ( twMemoEdit() )
#command  TSD MEMO EDIT <nTop>, <nLeft>, <nBottom>, <nRight> TO <cMemo> ;
                        [TITLE      <cTitle>]                 ;
                        [FOOTER     <cFooter>]                ;
                        [UDF        <cUdf>]                   ;
                        [ACTIONKEYS <aActKeys>]               ;
                        [WINCOLOR   <cColor>]                 ;
                        [SHADOW     <wShadow>]                ;
                        [FRAME      <wFrame>]                 ;
                        [FCOLOR     <FColor>]                 ;
                        [MESSAGE    <lMsg>]                   ;
                        [WRAP       <lWrap>]                  ;
                        [EDIT       <lEditMode>]              ;
                        [WIDTH      <nLineLength>]            ;
                        [TAB        <nTabSize>]               ;
                        [BUFFROW    <nTBurRow>]               ;
                        [BUFFCOL    <nTBurCol>]               ;
                        [WINROW     <nWinRow>]                ;
                        [WINCOL     <nWinCol>]                ;
                        [SCROLL     <lScrBar>]                ;
                        [WINDOW     <lWindow>]                ;
                        [PRERUN     <bPreRun>]                ;
                        [POSTRUN    <bPostRun>]               ;
                        [HELPVAR    <cHelpVar>]               ;
                        [HELPLEVEL  <nHelpLevel>]             ;
=> ;
 <cMemo> := twMemoEdit(<nTop>, <nLeft>, <nBottom>, <nRight>, <cMemo>,      ;
                       <cTitle>, <cFooter>, <cUdf>, <aActKeys>, <cColor>,  ;
                       <wShadow>, <wFrame>, <FColor>, <lMsg>, <lWrap>,     ;
                       <lEditMode>, <nLineLength>, <nTabSize>, <nTBufRow>, ;
                       <nTBufCol>, <nWinRow>, <nWinCol>, <lScrBar>,        ;
                       <lWindow>, <bPreRun>, <bPostRun>, <cHelpVar>, ;
                       <nHelpLevel>)
//
// Browse Full Array  ( twRABrowse() )

#command RABROWSETO  <nTop>, <nLeft>, ;
                     <nBottom>, <nRight> TO <nChoice>   ;
                     ARRAY   <aArray>        ;
                     COLUMNS <aColumns>      ;
                     [TITLE         <cTitle>]      ;
                     [EDIT          <lEditFlag>]   ;
                     [ACTIONKEYS    <aActKeys>]    ;
                     [COLOR         <cColor>]      ;
                     [SHADOW        <wShadow>]     ;
                     [FRAME         <wFrame>]      ;
                     [FCOLOR        <FColor>]      ;
                     [SCROLLBAR     <lScrBar>]     ;
                     [AUTOLITE      <lAutoLite>]   ;
                     [FREEZE        <nFreeze>]     ;
                     [STABILIZE     <lStabilize>]  ;
                     [PRERUN        <bPreRun>]     ;
                     [POSTRUN       <bPostRun>]    ;
                     [EXITKEY       <nExitKey>]    ;
                     [BAR           <lBarOn>]      ;
                     [SEPARATORS    <aSeparators>] ;
                     [APPENDBROWSE  <aAppend>]     ;
                     [SOUND         <lSound>]      ;
                     [WINDOW        <lWindow>]     ;
                     [BARCOLOR      <bBarColor>]   ;
                     [HELPVAR       <cHelpVar>]    ;
                     [HELPLEVEL     <nHelpLevel>]  ;
=>        ;
 <nChoice> := twRABrowse(<nTop>, <nLeft>, <nBottom>, <nRight>, <aArray>,   ;
                         <aColumns>, <cTitle>, <lEditFlag>, <aActKeys>,    ;
                         <cColor>, <wShadow>, <wFrame>, <FColor>,          ;
                         <lScrBar>, <lAutoLite>, <nFreeze>, <lStabilize>,  ;
                         <bPreRun>, <bPostRun>, <nExitKey>, <lBarOn>,      ;
                         <aSeparators>, <aAppend>, <lSound>, <lWindow>,    ;
                         <bBarColor>, <cHelpVar>, <nHelpLevel>)

#command RABROWSE <nTop>, <nLeft>, <nBottom>, <nRight> ;
                  ARRAY <aArray> COLUMNS <aColumns>     ;
                  [TITLE         <cTitle>]      ;
                  [EDIT          <lEditFlag>]   ;
                  [ACTIONKEYS    <aActKeys>]    ;
                  [COLOR         <cColor>]      ;
                  [SHADOW        <wShadow>]     ;
                  [FRAME         <wFrame>]      ;
                  [FCOLOR        <FColor>]      ;
                  [SCROLLBAR     <lScrBar>]     ;
                  [AUTOLITE      <lAutoLite>]   ;
                  [FREEZE        <nFreeze>]     ;
                  [STABILIZE     <lStabilize>]  ;
                  [PRERUN        <bPreRun>]     ;
                  [POSTRUN       <bPostRun>]    ;
                  [EXITKEY       <nExitKey>]    ;
                  [BAR           <lBarOn>]      ;
                  [SEPARATORS    <aSeparators>] ;
                  [APPENDBROWSE  <aAppend>]     ;
                  [SOUND         <lSound>]      ;
                  [WINDOW        <lWindow>]     ;
                  [BARCOLOR      <bBarColor>]   ;
                  [HELPVAR       <cHelpVar>]    ;
                  [HELPLEVEL     <nHelpLevel>]  ;
=>        ;
 twRABrowse(<nTop>, <nLeft>, <nBottom>, <nRight>, <aArray>,   ;
            <aColumns>, <cTitle>, <lEditFlag>, <aActKeys>,    ;
            <cColor>, <wShadow>, <wFrame>, <FColor>,          ;
            <lScrBar>, <lAutoLite>, <nFreeze>, <lStabilize>,  ;
            <bPreRun>, <bPostRun>, <nExitKey>, <lBarOn>,      ;
            <aSeparators>, <aAppend>, <lSound>, <lWindow>,    ;
            <bBarColor>, <cHelpVar>, <nHelpLevel>)

#command RACOLUMN <aColumns>                      ;
                  [COLUMN      <nColNumber>] ;
                  [HEADING     <cHead>]      ;
                  [WIDTH       <nWID>]       ;
                  [FOOTER      <cFooter>]    ;
                  [EDIT        <lEdit>]      ;
                  [PICTURE     <cPICTURE>]   ;
                  [WHEN        <bWhen>]      ;
                  [VALID       <bValid>]     ;
                  [READER      <bReader>]    ;
                  [COLOR       <aClr>]       ;
                  [COLORBLOCK  <bClr>]       ;
                  [COLSEP      <cCSep>]      ;
                  [HEADSEP     <cHSep>]      ;
                  [FOOTSEP     <cFSep>]      ;
=>           ;
   AAdd(<aColumns>, <cHead>, <nColNumber>, <nWid>, <cFooter>, <lEdit>,     ;
                    <cPicture>, <bWhen>, <bValid>, <bReader>, <aClr>,      ;
                    <bClr>, <cCSep>, <cHSep>, <cFSep>)
//
#command BRBROWSETO <nTop>, <nLeft>, <nBottom>, <nRight>  ;
                    TO <nChoice>                          ;
                    COLUMNS       <aColumns>              ;
                    [TITLE        <cTitle>]               ;
                    [TOPKEY       <cTopKey>]              ;
                    [SCOPEBLOCK   <bScopeBlock>]          ;
                    [EDIT         <lEditFlag>]            ;
                    [ACTIONKEYS   <aActionKeys>]          ;
                    [COLOR        <cColor>]               ;
                    [SHADOW       <nShadow>]              ;
                    [FRAME        <nFrame>]               ;
                    [FCOLOR       <cFColor>]              ;
                    [SCROLLBAR    <lScBar>]               ;
                    [MESSAGES     <lMsgs>]                ;
                    [AUTOLITE     <lAlite>]               ;
                    [FREEZE       <nFreeze>]              ;
                    [STABILIZE    <lStabilize>]           ;
                    [PRERUN       <bPreRun>]              ;
                    [POSTRUN      <bPostRun>]             ;
                    [EXITKEY      <nExitKey>]             ;
                    [SEPARATORS   <aSeparators>]          ;
                    [APPENDBROWSE <lOKAppend>]            ;
                    [SOUND        <lSound>]               ;
                    [WINDOW       <lWindow>]              ;
                    [BARCOLOR     <bBarColor>]            ;
                    [SEARCH       <aSrch>]                ;
                    [NETWORK      <lNetWork>]             ;
                    [HELPVAR      <cHelpVar>]             ;
                    [HELPLEVEL    <nHelpLevel>]           ;
=>        ;
<nChoice> := twBRBrowse( <nTop>, <nLeft>, <nBottom>, <nRight>, <aColumns>, ;
                   <cTitle>, <cTopKey>, <bScopeBlock>, <lEditFlag>,        ;
                   <aActionKeys>, <cColor>, <nShadow>, <nFrame>, <cFColor>, ;
                   <lScBar>, <lMsgs>, <lAlite>, <nFreeze>, <lStabilize>,   ;
                   <bPreRun>, <bPostRun>, <nExitKey>, <aSeparators>,       ;
                   <lOKAppend>, <lSound>, <lWindow>, <bBarColor>, <aSrch>, ;
                   <lNetWork>, <cHelpVar>, <nHelpLevel> )


#command  BRBROWSE <nTop>, <nLeft>, <nBottom>, <nRight>  ;
                   COLUMNS       <aColumns>              ;
                   [TITLE        <cTitle>]               ;
                   [TOPKEY       <cTopKey>]              ;
                   [SCOPEBLOCK   <bScopeBlock>]          ;
                   [EDIT         <lEditFlag>]            ;
                   [ACTIONKEYS   <aActionKeys>]          ;
                   [COLOR        <cColor>]               ;
                   [SHADOW       <nShadow>]              ;
                   [FRAME        <nFrame>]               ;
                   [FCOLOR       <cFColor>]              ;
                   [SCROLLBAR    <lScBar>]               ;
                   [MESSAGES     <lMsgs>]                ;
                   [AUTOLITE     <lAlite>]               ;
                   [FREEZE       <nFreeze>]              ;
                   [STABILIZE    <lStabilize>]           ;
                   [PRERUN       <bPreRun>]              ;
                   [POSTRUN      <bPostRun>]             ;
                   [EXITKEY      <nExitKey>]             ;
                   [SEPARATORS   <aSeparators>]          ;
                   [APPENDBROWSE <lOKAppend>]            ;
                   [SOUND        <lSound>]               ;
                   [WINDOW       <lWindow>]              ;
                   [BARCOLOR     <bBarColor>]            ;
                   [SEARCH       <aSrch>]                ;
                   [NETWORK      <lNetWork>]             ;
                   [HELPVAR      <cHelpVar>]             ;
                   [HELPLEVEL    <nHelpLevel>]           ;
=>        ;
twBRBrowse( <nTop>, <nLeft>, <nBottom>, <nRight>, <aColumns>,       ;
            <cTitle>, <cTopKey>, <bScopeBlock>, <lEditFlag>,        ;
            <aActionKeys>, <cColor>, <nShadow>, <nFrame>, <cFColor>, ;
            <lScBar>, <lMsgs>, <lAlite>, <nFreeze>, <lStabilize>,   ;
            <bPreRun>, <bPostRun>, <nExitKey>, <aSeparators>,       ;
            <lOKAppend>, <lSound>, <lWindow>, <bBarColor>, <aSrch>, ;
            <lNetWork>,  <cHelpVar>, <nHelpLevel> )

#command BRCOLUMN <aColumns>             ;
                  [HEADING    <cHead>]   ;
                  [BLOCK      <bBlk>]    ;
                  [WIDTH      <nWid>]    ;
                  [FOOTER     <cFoot>]   ;
                  [EDIT       <lEdit>]   ;
                  [PICTURE    <cPic>]    ;
                  [WHEN       <bWhn>]    ;
                  [VALID      <bVld>]    ;
                  [READER     <bRdr>]    ;
                  [COLOR      <aClr>]    ;
                  [COLORBLOCK <bClr>]    ;
                  [COLSEP     <cCsep>]   ;
                  [HEADSEP    <cHsep>]   ;
                  [FOOTSEP    <cFsep>]   ;
=>           ;
    AADD( aColumns, { <cHead>, <bBlk>, <nWid>, <cFoot>, <lEdit>, <cPic>, <bWhn>, <bVld>, ;
                      <bRdr>, <aClr>, <bClr>, <cCsep>, <cHsep>, <cFsep> })
/*

 Calculator Commands

*/
#command CALCINIT AT <nTop>, <nLeft> [COLOR <cColor>] [SHADOW <nShadow>] ;
                     [FRAME <nFrame>] [FCOLOR <cFColor>] [PASTE <lPaste>] ;
         => ;
         twCalcInit( <nTop>, <nLeft>, <cColor>, <nShadow>, <nFrame>, <cFColor>, <.lPaste.> )

#command CALCINIT ;
         => ;
         twCalcInit()

#command CALCULATOR TO <nkey> ;
         => ;
         SET KEY <nkey> TO twCallCalc()

#command RESET CALCULATOR ;
         => ;
         ERASE *.CLC
/*

 Get System Commands

*/
#command Tsd Clear Gets   =>  ClearMouseGet( GetList )
#command TSD CLEAR GETS   =>  ClearMouseGet( GetList )
/*

 Wait State Commands

*/
#command TWWAIT <nWait> [HELPVAR <cHelpVar>] [HELPLEVEL <nHelpLevel>];
         => ;
         twInkeyWait( <nWait>, <cHelpVar>, <nHelpLevel> )
/*

 Miscellaneous Commands and Translates

*/
#xtranslate twMakeShadowArea( <nTop>, <nLeft>, <nBottom>, <nRight>, <nShadow> );
            => ;
            twShadow( <nTop>, <nLeft>, <nBottom>, <nRight>, <nShadow>, .T. )

#translate MAKEWSHAD( <r1>, <c1>, <r2>, <c2> ) ;
           => ;
           RESTSCREEN( <r1>, <c1>, <r2>, <c2>, _twAttrChg(;
           SAVESCREEN( <r1>, <c1>, <r2>, <c2> ), IIF( ISCOLOR(), 8, 7 )))

#command GETSTRUCT ;
         => ;
         twGetStruct(@sT,@sL,@sB,@sR,@wT,@wL,@wB,@wR,@tShadow,@tScr,;
            @uScr,@tlength,@twidth,@tThick,@sh13,@sh17,@sh79,@sh39)

#command SETSTRUCT ;
         => ;
         twSetStruct(wT,wL,wB,wR,sT,sL,sB,sR,uScr)
/*

 No Mouse Compiling Defines

*/
#ifdef NOMOUSE
    #define twBRBarDisp     ntwBRBarDisp
    #define twBRBrowse      ntwBRBrowse
    #define twBRGetBrowse   ntwBRGetBrowse
    #define twBRNewSearch   ntwBRNewSearch

    #define twRABrowse      ntwRABrowse
    #define twRAGetBrowse   ntwRAGetBrowse
    #define twRAGetCurrent  ntwRAGetCurrent
    #define twRAGetArray    ntwRAGetArray
    #define twRASetArray    ntwRASetArray
    #define twRAGetElement  ntwRAGetElement
    #define twRABarDisp     ntwRABarDisp

    #define twABBrowse      ntwABBrowse
    #define twABGetBrowse   ntwABGetBrowse
    #define twABBarDisp     ntwABBarDisp

    #define twACChoice      ntwACChoice

    #define twPopChoice     ntwPopChoi

    #define twARPick        ntwARPick
    #define twDBPick        ntwDBPick

    #define twMenuTo        ntwMenuTo
    #define twMenuGetElem   ntwMenuGetElem
    #define twMenuInit      ntwMenuInit
    #define twMenuSetClr    ntwMenuSetClr

    #define twPopMenu       ntwPopMenu
    #define twLineMenu      ntwLineMenu

    #define twAMsgInit      ntwAMsgInit
    #define twWarnLine      ntwWarnLine
    #define twInfoLine      ntwInfoLine
    #define twAMsgEnd       ntwAMsgEnd
    #define twAMPop         ntwAMPop
    #define twAMClose       ntwAMClose

    #define twMsgInit       ntwMsgInit
    #define twWarn          ntwWarn
    #define twInfo          ntwInfo
    #define twInquire       ntwInquire
    #define twTextMsg       ntwTextMsg
    #define twMsgEnd        ntwMsgEnd
    #define twMPop          ntwMPop

    #define twAlertInit     ntwAlertInit
    #define twRadioBox      ntwRadioBox
    #define twCheckBox      ntwCheckBox
    #define twButtonBox     ntwButtonBox

    #define twMemoEdit      ntwMemoEdit
    #define twMemoView      ntwMemoView
    #define twMemoUdf       ntwMemoUdf
    #define twHelpUdf       ntwHelpUdf

    #define twTextFile      ntwTextFile

    //#xtranslate twReadModal( <n>[, <m>] );
    //            =>;
    //            ntwReadmodal( <n> )
    #define twReadModal     ntwReadModal
    #define twGetReader     ntwGetReader
    #define twGetApplyKey   ntwGetApplyKey

    #define twDBrowse       ntwDBrowse
    #define twGetDBrowse    ntwGetDBrowse

    #define twIndexMaker    ntwIndexMaker
    #define twIndexDisp     ntwIndexDisp

    #define twArBrowse      ntwArBrowse
    #define twGetABrowse    ntwGetABrowse
    #define twGetCurElem    ntwGetCurElem

    #define twIsDrive       ntwIsDrive

    #define twPrReady       ntwPrReady

    #define twBackUp        ntwBackUp
    #define twRestore       ntwRestore

    #define twNetUse        ntwNetUse
    #define twNetUse1       ntwNetUse1
    #define twFileLock      ntwFileLock
    #define twRecLock       ntwRecLock
    #define twAddRec        ntwAddRec
    #define twSemLock       ntwSemLock
    #define twSemUnlock     ntwSemUnlock
    #define twNetInit       ntwNetInit

    #define twHelp          ntwHelp
    #define twHelpInit      ntwHelpInit
    #define twMakeHelp      ntwMakeHelp
    #define twHelpColor     ntwHelpColor
    #define twHelpFColor    ntwHelpFColor
    #define twHelpTColor    ntwHelpTColor
    #define twHelpShadow    ntwHelpShadow
    #define twHelpFrame     ntwHelpFrame

#endif
